package com.gic.store.service;

import com.gic.api.base.commons.Page;
import com.gic.api.base.commons.ServiceResponse;
import com.gic.store.dto.StoreDTO;
import com.gic.store.dto.StoreWidgetDTO;
import com.sun.imageio.plugins.common.I18N;

import java.util.List;

public interface StoreWidgetApiService {

    /** @Description: 保存门店选择器内容
     * @author taogs
     * @Date 18:49 2019/9/20
     * @Param
     * @return
    */
    ServiceResponse<Integer> saveStoreWidget(StoreWidgetDTO storeWidgetDTO);


    /** @Description: 保存权限门店选择器（管理员和联合商户专用）
     * @author taogs
     * @Date 18:49 2019/9/20
     * @Param
     * @return
    */
    ServiceResponse<Integer> saveAuthStoreWidget(StoreWidgetDTO storeWidgetDTO);


    /** @Description: 获取门店选择器内容
     * @author taogs
     * @Date 18:49 2019/9/20
     * @Param
     * @return
    */
    ServiceResponse<StoreWidgetDTO> getStoreWidget(Integer id);

    /** @Description: 更新选择器的权限内容
     * @author taogs
     * @Date 18:50 2019/9/20
     * @Param
     * @return
    */
    ServiceResponse<Integer> updateAuth(StoreWidgetDTO storeWidgetDTO);

    
    /** @Description: 通过门店控件id查询门店
     * @author taogs
     * @Date 16:35 2019/12/4
     * @Param 
     * @return 
    */
    ServiceResponse<Page<StoreDTO>> listStoreByStoreWidgetId(Integer enterpriseId, Integer storeWidgetId, int pageNum, int pageSize);

    ServiceResponse<List<Integer>> listStoreIdByStoreWidgetId(Integer enterpriseId, Integer storeWidgetId);
}
