package com.gic.store.dao.mapper;

import com.gic.store.entity.TabStoreExtend;
import org.apache.ibatis.annotations.Param;

import java.util.List;

public interface TabStoreExtendMapper {
    /**
     * 根据主键删除
     *
     * @param storeExtendId 主键
     * @return 更新条目数
     */
    int deleteByPrimaryKey(Integer storeExtendId);

    /**
     * 插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insert(TabStoreExtend record);

    /**
     * 动态插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insertSelective(TabStoreExtend record);

    /**
     * 根据主键查询
     *
     * @param storeExtendId 主键
     * @return 实体对象
     */
    TabStoreExtend selectByPrimaryKey(Integer storeExtendId);

    /**
     * 根据主键动态更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKeySelective(TabStoreExtend record);

    /**
     * 根据主键更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKey(TabStoreExtend record);

    List<TabStoreExtend> list(@Param("enterpriseId") Integer enterpriseId, @Param("storeInfoId") Integer storeInfoId);

    TabStoreExtend getStoreExtendByStoreInfoIdAndStoreFieldId(@Param("storeInfoId") Integer storeInfoId, @Param("storeFieldId") Integer storeFieldId);

    int countStoreExtendStoreField(@Param("storeField") Integer storeField, @Param("storeFieldSelectId") Integer storeFieldSelectId);

    int countExtendByValue(@Param("storeFieldId") Integer storeFieldId, @Param("value") String value, @Param("storeExtendId") Integer storeExtendId);
}