package com.gic.store.dao.mapper;

import com.gic.store.entity.TabStore;
import org.apache.ibatis.annotations.Param;

import java.util.List;

public interface TabStoreMapper {
    /**
     * 根据主键删除
     *
     * @param storeId 主键
     * @return 更新条目数
     */
    int deleteByPrimaryKey(Integer storeId);

    /**
     * 插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insert(TabStore record);

    /**
     * 动态插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insertSelective(TabStore record);

    /**
     * 根据主键查询
     *
     * @param storeId 主键
     * @return 实体对象
     */
    TabStore selectByPrimaryKey(Integer storeId);

    /**
     * 根据主键动态更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKeySelective(TabStore record);

    /**
     * 根据主键更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKey(TabStore record);

    Integer updateGroupId(@Param("oldStoreGroupId") Integer oldStoreGroupIds, @Param("newStoreGroupId") Integer newStoreGroupId);

    int updateAllStoreGroup(@Param("enterpriseId") Integer enterpriseId, @Param("value") Integer value);

    int updateStoreGroupBystoreInfoIds(@Param("enterpriseId") Integer enterpriseId,
                                       @Param("value") Integer value,
                                       @Param("storeIdList") List<Integer> storeIdList);

    List<TabStore> getStoreNoStatus(@Param("enterpriseId") Integer enterpriseId, @Param("storeInfoId") Integer storeInfoId);

    List<Integer> listStoreIdByFromEnterpriseId(@Param("fromEnterpriseId") Integer fromEnterpriseId);

    int cancelAuthStore(@Param("storeInfoIdList") List<Integer> storeInfoIdList, @Param("toEnterpriseId") Integer toEnterpriseId);

    int cancelAuthStoreAll(@Param("fromEnterpriseId") Integer fromEnterpriseId,
                        @Param("toEnterpriseId") Integer toEnterpriseId);

    List<Integer> listStoreInfoIdByStoreIds(@Param("ids") List<Integer> ids, @Param("enterpriseId") Integer enterpriseId);

    List<String> listAllCityId(@Param("enterpriseId") Integer enterpriseId,
                               @Param("storeBrandId") Integer storeBrandId);
}