package com.gic.store.dao.mapper;

import com.gic.store.entity.TabStorePhoto;
import org.apache.ibatis.annotations.Param;

import java.util.Date;
import java.util.List;

public interface TabStorePhotoMapper {
    /**
     * 根据主键删除
     *
     * @param storePhotoId 主键
     * @return 更新条目数
     */
    int deleteByPrimaryKey(Integer storePhotoId);

    /**
     * 插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insert(TabStorePhoto record);

    /**
     * 动态插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insertSelective(TabStorePhoto record);

    /**
     * 根据主键查询
     *
     * @param storePhotoId 主键
     * @return 实体对象
     */
    TabStorePhoto selectByPrimaryKey(Integer storePhotoId);

    /**
     * 根据主键动态更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKeySelective(TabStorePhoto record);

    /**
     * 根据主键更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKey(TabStorePhoto record);

    List<TabStorePhoto> listStorePhoto(@Param("enterpriseId") Integer enterpriseId, @Param("storeInfoId") Integer storeId);

    int updateAllStorePhoto(@Param("imageCode") String imageCode, @Param("imageUrl")String imageUrl, @Param("sort") int sort, @Param("enterpriseId") Integer enterpriseId);

    int updatePhotoBystoreInfoIds(@Param("imageCode") String imageCode, @Param("imageUrl")String imageUrl, @Param("sort") int sort, @Param("storeIdList") List<Integer> storeIdList);

    int deleteAllByEnterpriseId(@Param("enterpriseId") Integer enterpriseId);

    int deleteBystoreInfoIds(@Param("enterpriseId") Integer enterpriseId, @Param("storeIdList") List<Integer> storeIdList);

    int addAllStorePhoto(@Param("imageCode") String imageCode, @Param("imageUrl")String imageUrl, @Param("sort") int sort, @Param("enterpriseId") Integer enterpriseId);

    int addPhotoBystoreInfoIds(@Param("imageCode") String imageCode, @Param("imageUrl")String imageUrl, @Param("sort") int sort, @Param("storeIdList") List<Integer> storeIdList);

}