package com.gic.store.strategy.impl;

import com.gic.store.entity.TabStoreBrand;
import com.gic.store.service.StoreBrandService;
import com.gic.store.service.StoreLogService;
import com.gic.store.service.StoreService;
import com.gic.store.strategy.BulkUpdateStoreStrtegy;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Optional;

@Component
public class StoreBrandUpdateStrategyImpl implements BulkUpdateStoreStrtegy {

    @Autowired
    private StoreLogService storeLogService;
    @Autowired
    private StoreBrandService storeBrandService;

    @Override
    public int bulkUpdateStore(String storeIds, Integer enterpriseId, String value, StoreService storeService, Integer operatorId, String operatorName) {
        int i = storeService.bulkUpdateStoreBrands(storeIds, enterpriseId, value);
        if (i > 0) {
            List<Integer> storeIdList;
            if ("all".equals(storeIds)) {
                storeIdList = storeService.listAllStoreId(enterpriseId);
            } else {
                storeIdList = new ArrayList<>();
                String[] storeIdArr = storeIds.split(",");
                for (String s : storeIdArr) {
                    storeIdList.add(Integer.valueOf(s));
                }
            }
            List<TabStoreBrand> storeBrandList = storeBrandService.listStoreBrandByIds(storeIds);
            String content = Optional.ofNullable(storeBrandList).orElse(Collections.emptyList()).stream().map(TabStoreBrand::getStoreBrandName).reduce((x, y) -> x + "," + y).orElse("");
            storeLogService.saveBulkStoreInfoLog(storeIdList, enterpriseId, operatorId, operatorName, "门店品牌变更为【" + content + "】");
        }
        return i;
    }
}
