package com.gic.store.strategy.impl;

import com.gic.store.service.StoreLogService;
import com.gic.store.service.StoreService;
import com.gic.store.strategy.BulkUpdateStoreStrtegy;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;
@Component
public class StorePhotoUpdateStrategyImpl implements BulkUpdateStoreStrtegy {

    @Autowired
    private StoreLogService storeLogService;

    @Override
    public int bulkUpdateStore(String storeIds, Integer enterpriseId, String value, StoreService storeService, Integer operatorId, String operatorName) {
        int i = storeService.bulkUpdateStorePhoto(storeIds, enterpriseId, value);
        if (i > 0) {
            List<Integer> storeIdList;
            if ("all".equals(storeIds)) {
                storeIdList = storeService.listAllStoreId(enterpriseId);
            } else {
                storeIdList = new ArrayList<>();
                String[] storeIdArr = storeIds.split(",");
                for (String s : storeIdArr) {
                    storeIdList.add(Integer.valueOf(s));
                }
            }
            storeLogService.saveBulkStoreInfoLog(storeIdList, enterpriseId, operatorId, operatorName, "门店照片变更");
        }
        return i;
    }
}
